#include "base.h"

#define T Base_T

void
Base_print (T base) {
  switch (base) {
  case A: printf("A"); break;
  case C: printf("C"); break;
  case G: printf("G"); break;
  case U: printf("T"); break;
  case N: printf("N"); break;
  }
}


char
Base_char (T base) {
  switch (base) {
  case A: return 'A';
  case C: return 'C';
  case G: return 'G';
  case U: return 'T';
  case N: return 'N';
  default: return 'N';
  }
}

T 
Base_antisense (T base) {
  switch (base) {
  case A: return U;
  case C: return G;
  case G: return C;
  case U: return A;
  case N: return N;
  default: return N;
  }
}


int
Base_dimer_index (T b1, T b2) {
  if (b1 == N || b2 == N) {
    return -1;
  } else {
    return NUM_BASES*b1+b2;
  }
}

